package com.zt.plat.module.base.service.base;

import com.zt.plat.framework.common.pojo.PageResult;
import com.zt.plat.module.base.controller.admin.base.vo.FactoryPageReqVO;
import com.zt.plat.module.base.controller.admin.base.vo.FactoryRespVO;
import com.zt.plat.module.base.controller.admin.base.vo.FactorySaveReqVO;
import com.zt.plat.module.base.dal.dataobject.base.FactoryDO;
import jakarta.validation.Valid;

import java.util.List;

/**
 * 工厂 Service 接口
 *
 * @author 后台管理
 */
public interface FactoryService {

    /**
     * 创建工厂
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    FactoryRespVO createFactory(@Valid FactorySaveReqVO createReqVO);

    /**
     * 更新工厂
     *
     * @param updateReqVO 更新信息
     */
    void updateFactory(@Valid FactorySaveReqVO updateReqVO);

    /**
     * 删除工厂
     *
     * @param id 编号
     */
    void deleteFactory(Long id);

    /**
    * 批量删除工厂
    *
    * @param ids 编号
    */
    void deleteFactoryListByIds(List<Long> ids);

    /**
     * 获得工厂
     *
     * @param id 编号
     * @return 工厂
     */
    FactoryDO getFactory(Long id);

    /**
     * 获得工厂分页
     *
     * @param pageReqVO 分页查询
     * @return 工厂分页
     */
    PageResult<FactoryDO> getFactoryPage(FactoryPageReqVO pageReqVO);

    void enableFactoryList(List<FactoryRespVO> saveReqVOS);
}